//=============================================================================
// Lift exit type
// Targeted pathing to the lift center i'm aiming at
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class Botz_LiftJumpExit expands Botz_LiftExit;

//Called after botZ decides this is the path to take
//Do some lift handling here?
function bool PostPathEvaluate( botz other)
{
	if ( MyMover == none )
		return false;
//	if ( !other.PointReachable(location) )
	if ( true ) //Unreachable always assumed
	{
		//Temporary solution
		if ( (other.Base == MyMover) && !MyMover.bInterpolating  && !MyMover.bDelaying )
		{
			other.MoveTarget = other;
			other.SpecialPause = 0.5;
			other.bTickedJump = true;
		}
		else if ( other.Base == MyMover )
		{
			if ( Other.BFM.CanFlyTo( Other.Location, Location, Region.Zone.ZoneGravity.Z, Other.JumpZ + MyMover.Velocity.Z, Other.AirSpeed) )
			{
				Other.HighJump( self, true);
				return true;
			}
			other.SpecialPause = 0.1;
			other.StopMoving( true);
			other.GotoState( other.GetStateName(), 'SpecialWait');
		}
		return true;
	}
	return false;
}



defaultproperties
{
	FriendlyName="Lift Jump Exit"
}