//=============================================================================
// F_TempDest.
// Temporarily alter a destination
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class F_TempDest expands InfoPoint;

var Actor SavedDest;
var MasterGasterFer Master;
var F_TempDest NextDest;
var Botz B;

//During movement
function F_TempDest Setup( Botz newB, Actor newSD, float ExpireTime, vector Position)
{
	B = newB;
	bHidden = !B.DebugMode;
	SavedDest = newSD;
	SetTimer( ExpireTime, false);
	SetLocation( Position);
	B.LifeSignal( ExpireTime);
	if ( B.SpecialMoveTarget == none )
		B.SwitchToUnstate();
	B.SpecialMoveTarget = self;
	return self;
}

//Before movement, doesn't set variables on bot
function F_TempDest PassiveSetup( Botz newB, Actor newSD, float ExpireTime, vector Position)
{
	B = newB;
	bHidden = !B.DebugMode;
	SavedDest = newSD;
	SetTimer( ExpireTime, false);
	SetLocation( Position);
	B.LifeSignal( ExpireTime);
	return self;
}

event Timer()
{
	Expire();
}

function Expire()
{
	SetTimer(0, false);
	if ( B != none )
	{
		if ( B.SpecialMoveTarget == self )
		{
			B.SpecialMoveTarget = SavedDest;
			B.LifeSignal(1);
		}
	}
	B = none;
	SavedDest = none;
	NextDest = Master.PoolDests;
	Master.PoolDests = self;
}

defaultproperties
{
    bHidden=True
}