/*===========================================================================
    C++ class definitions exported from UnrealScript.
===========================================================================*/
#if _MSC_VER
#pragma pack (push,4)
#endif

#ifndef FERBOTZ_API
#define FERBOTZ_API DLL_IMPORT
#endif

#ifndef NAMES_ONLY
#define AUTOGENERATE_NAME(name) extern FERBOTZ_API FName FERBOTZ_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name)
#endif

AUTOGENERATE_NAME(ModifyFlags)
AUTOGENERATE_NAME(IsCandidateTo)
AUTOGENERATE_NAME(OtherIsCandidate)
AUTOGENERATE_NAME(AddPathHere)
AUTOGENERATE_NAME(FinishedPathing)

#ifndef NAMES_ONLY

enum ESecondaryActions
{
    SA_Hunting              =0,
    SA_None                 =1,
    SA_Sniping              =2,
    SA_Supporting           =3,
    SA_Covering             =4,
    SA_MAX                  =5,
};
enum EMainActionList
{
    MAL_None                =0,
    MAL_Attacking           =1,
    MAL_Defending           =2,
    MAL_Following           =3,
    MAL_Freelancing         =4,
    MAL_Holding             =5,
    MAL_CarryingFlag        =6,
    MAL_InitialStand        =7,
    MAL_MAX                 =8,
};
enum EAttackDistance
{
    AD_Cercana              =0,
    AD_Media                =1,
    AD_Larga                =2,
    AD_MAX                  =3,
};
#define UCONST_AngleFactor 182.044444444444444444444444444
#define UCONST_MaxTactical 5.0
#define UCONST_MinTactical 0.0
#define UCONST_MinAccuracy 5.0
#define UCONST_MaxAccuracy 0.0
#define UCONST_MaxSkill 7.0

class FERBOTZ_API ABotz : public APawn
{
public:
    class ABotzFunctionManager* BFM;
    class UClass* MySimulated;
    class APlayerPawn* DummyPawn;
    BITFIELD bSpawnedByUser:1 GCC_PACK(4);
    BITFIELD bIgnoredByMutator:1;
    BITFIELD bNative:1;
    INT iIndex GCC_PACK(4);
    class UClass* CarcassType;
    class UTexture* StatusDoll;
    class UTexture* StatusBelt;
    FStringNoInit DefaultSkinName;
    FName SubOrders;
    class AActor* SubOrderObject;
    FName Orders;
    class AActor* OrderObject;
    FStringNoInit OObjectName;
    FName SavedState;
    FName SavedLabel;
    FName OldSubOrders;
    class AActor* OldSubOrderObject;
    FName ForceState;
    FName ForceLabel;
    FLOAT MinDesiredDelta;
    BITFIELD bHumanMove:1 GCC_PACK(4);
    FVector FireOffset GCC_PACK(4);
    class UClass* ArmaFavorita;
    BITFIELD Suicida:1 GCC_PACK(4);
    FLOAT Punteria GCC_PACK(4);
    FLOAT TacticalAbility;
    FLOAT TrackingAbility;
    FLOAT Aggresiveness;
    INT AvgCampTime;
    FLOAT CampChance;
    INT MaxCampTime;
    INT iCampTime;
    class AActor* ProximoCamp;
    BITFIELD bDoesCamp:1 GCC_PACK(4);
    BITFIELD bCamping:1;
    BITFIELD bSniping:1;
    BITFIELD bWeaponCamp:1;
    BITFIELD bNeverLeaveDefense:1;
    BITFIELD bDebugLog:1;
    class AActor* LastAmbushSpot GCC_PACK(4);
    class AAmbushpoint* AmbushSpot;
    class AAmbushpoint* PuntoDeCamping;
    BITFIELD bMultiDefense:1 GCC_PACK(4);
    class AFortStandard* MyDefenseFort GCC_PACK(4);
    class USound* drown;
    class USound* breathagain;
    class USound* Footstep1;
    class USound* Footstep2;
    class USound* Footstep3;
    class USound* HitSound3;
    class USound* HitSound4;
    class USound* Deaths[6];
    class USound* GaspSound;
    class USound* UWHit1;
    class USound* UWHit2;
    class USound* LandGrunt;
    class USound* JumpSound;
    class AActor* GameTarget;
    class AActor* ObjetivoPrimario;
    class AActor* ObjetivoSecundario;
    class AActor* MiBase;
    class AActor* FinalMoveTarget;
    class AActor* SpecialMoveTarget;
    class AAlternatePath* AttackVariation;
    BITFIELD bTouchedAlternate:1 GCC_PACK(4);
    BITFIELD bMustChange:1;
    BITFIELD bShouldDuck:1;
    class ABotzMutator* MyMutator GCC_PACK(4);
    class ABotzFollowTrail* theTrail;
    class AMasterGasterFer* MasterEntity;
    class ABotz_BaddingSpot* MyBads;
    INT BadCount;
    class UFlightProfileBase* FlightProfiles[8];
    class UFlightProfileBase* CurFlight;
    INT iFlight;
    FLOAT LastAnimFrame;
    class AControlPoint* ControlPointList[64];
    INT iCP;
    BITFIELD bCpEv:1 GCC_PACK(4);
    BITFIELD bGeneralCheck:1;
    BITFIELD bPatrolUp:1;
    class AActor* PatrolStops[16] GCC_PACK(4);
    INT CurrentPatrol;
    class ATranslocator* MyTranslocator;
    BITFIELD bHasTranslocator:1 GCC_PACK(4);
    BITFIELD bHasImpactHammer:1;
    BITFIELD bFlagCarrier:1;
    BITFIELD bPendingTransloc:1;
    BITFIELD bCanTranslocate:1;
    class ANavigationPoint* LastNode GCC_PACK(4);
    class AActor* PendingSpot;
    class ALiftCenter* WaitLift;
    class ALiftExit* OldLift;
    FLOAT TeleTick;
    BITFIELD bLastNone:1 GCC_PACK(4);
    FLOAT RespawnTime GCC_PACK(4);
    class AInfoPoint* CampPoint;
    class AInfoPoint* MySniperPoint;
    class AInfoPoint* PingPongPoint;
    class AInfoPoint* MyHoldSpot;
    class AAimOffsetPoint* AimPoint;
    class APlayerPawn* JugadorSimulado;
    BITFIELD bHasToJump:1 GCC_PACK(4);
    BITFIELD SharingSpots:1;
    BITFIELD CriticalSituation:1;
    BITFIELD bSuperAccel:1;
    BITFIELD bUnstateMove:1;
    class AF_HoldPosition* SharedSpots[8] GCC_PACK(4);
    FName NextAnim;
    FLOAT LastTranslocCounter;
    FLOAT NoDeleteTranslocs;
    BITFIELD bAirTransloc:1 GCC_PACK(4);
    BITFIELD bHadTTarget:1;
    BYTE AttackDistance GCC_PACK(4);
    FVector BestDodgeLocation;
    class AProjectile* DangerM;
    FLOAT Accumulator;
    FName OldMessageType;
    INT OldMessageID;
    BITFIELD bTurnControl:1 GCC_PACK(4);
    BITFIELD bWasWaiting:1;
    BITFIELD DebugMode:1;
    class AActor* ImpactTarget GCC_PACK(4);
    FLOAT TiempoDeVida;
    BITFIELD bGameStarted:1 GCC_PACK(4);
    BITFIELD bTickedJump:1;
    FLOAT Precaucion GCC_PACK(4);
    BITFIELD bSuperAim:1 GCC_PACK(4);
    class UBotzWeaponProfile* WeaponProfile GCC_PACK(4);
    class AActor* MyCombo;
    FLOAT ExecuteAgain;
    FStringNoInit CurrentTactic;
    FLOAT MoveAgain;
    FLOAT CombatParamA;
    FLOAT CombatParamB;
    INT CombatInt;
    BITFIELD bKeepEnemy:1 GCC_PACK(4);
    BITFIELD bCombatBool:1;
    FLOAT CombatWeariness GCC_PACK(4);
    FLOAT ChargeFireTimer;
    FLOAT TacticExpiration;
    FLOAT DistractionLimit;
    FLOAT DodgeAgain;
    FLOAT SafeAimDist;
    BITFIELD bCoverAdv:1 GCC_PACK(4);
    FLOAT ChatCounter GCC_PACK(4);
    FLOAT RadioCounter;
    BYTE FrontActions;
    BYTE SideActions;
    FStringNoInit PlayerNamez;
    FName PlayerOrderz;
    FStringNoInit TriggerCommand;
    FStringNoInit TheClassZ;
    DECLARE_FUNCTION(execNavigationActors);
    DECLARE_FUNCTION(execPawnActors);
    DECLARE_FUNCTION(execFindBasedInv);
    DECLARE_FUNCTION(execOr_ActorActor);
    DECLARE_FUNCTION(execPopRouteCache);
    DECLARE_FUNCTION(execCollideTrace);
    DECLARE_CLASS(ABotz,APawn,0|CLASS_Config,FerBotz)
    NO_DEFAULT_CONSTRUCTOR(ABotz)
};

enum EPathMode
{
    PM_None                 =0,
    PM_Normal               =1,
    PM_Forced               =2,
    PM_MAX                  =3,
};

struct ABotz_NavigBase_eventFinishedPathing_Parms
{
};
struct ABotz_NavigBase_eventAddPathHere_Parms
{
    class ANavigationPoint* Start;
    class ANavigationPoint* End;
    BITFIELD bForce;
};
struct ABotz_NavigBase_eventOtherIsCandidate_Parms
{
    class ANavigationPoint* Nav;
    BYTE ReturnValue;
};
struct ABotz_NavigBase_eventIsCandidateTo_Parms
{
    class ABotz_NavigBase* Other;
    BYTE ReturnValue;
};
struct ABotz_NavigBase_eventModifyFlags_Parms
{
    class ANavigationPoint* Dest;
    INT CurFlags;
    INT ReturnValue;
};
class FERBOTZ_API ABotz_NavigBase : public ANavigationPoint
{
public:
    FLOAT MaxDistance;
    BITFIELD bPushSave:1 GCC_PACK(4);
    BITFIELD bOneWayInc:1;
    BITFIELD bOneWayOut:1;
    BITFIELD bFlying:1;
    BITFIELD bHighPath:1;
    BITFIELD bCustomFlags:1;
    BITFIELD bDirectConnect:1;
    BITFIELD bNeverPrune:1;
    BITFIELD bFinishedPathing:1;
    INT ReservePaths GCC_PACK(4);
    INT ReserveUpstreamPaths;
    FStringNoInit FriendlyName;
    class ABotz_PathLoader* MyLoader;
    DECLARE_FUNCTION(execFreeUpstreamSlot);
    DECLARE_FUNCTION(execFreePathSlot);
    DECLARE_FUNCTION(execClearAllPaths);
    DECLARE_FUNCTION(execIsConnectedTo);
    DECLARE_FUNCTION(execConnectedDests);
    DECLARE_FUNCTION(execUnusedReachSpec);
    DECLARE_FUNCTION(execEditReachSpec);
    DECLARE_FUNCTION(execExistingPath);
    DECLARE_FUNCTION(execPathCandidates);
    DECLARE_FUNCTION(execCreateReachSpec);
    DECLARE_FUNCTION(execLockActor);
    void eventFinishedPathing()
    {
        ProcessEvent(FindFunctionChecked(FERBOTZ_FinishedPathing),NULL);
    }
    void eventAddPathHere(class ANavigationPoint* Start, class ANavigationPoint* End, BITFIELD bForce)
    {
        ABotz_NavigBase_eventAddPathHere_Parms Parms;
        Parms.Start=Start;
        Parms.End=End;
        Parms.bForce=bForce;
        ProcessEvent(FindFunctionChecked(FERBOTZ_AddPathHere),&Parms);
    }
    BYTE eventOtherIsCandidate(class ANavigationPoint* Nav)
    {
        ABotz_NavigBase_eventOtherIsCandidate_Parms Parms;
        Parms.Nav=Nav;
        Parms.ReturnValue=0;
        ProcessEvent(FindFunctionChecked(FERBOTZ_OtherIsCandidate),&Parms);
        return Parms.ReturnValue;
    }
    BYTE eventIsCandidateTo(class ABotz_NavigBase* Other)
    {
        ABotz_NavigBase_eventIsCandidateTo_Parms Parms;
        Parms.Other=Other;
        Parms.ReturnValue=0;
        ProcessEvent(FindFunctionChecked(FERBOTZ_IsCandidateTo),&Parms);
        return Parms.ReturnValue;
    }
    INT eventModifyFlags(class ANavigationPoint* Dest, INT CurFlags)
    {
        ABotz_NavigBase_eventModifyFlags_Parms Parms;
        Parms.Dest=Dest;
        Parms.CurFlags=CurFlags;
        Parms.ReturnValue=0;
        ProcessEvent(FindFunctionChecked(FERBOTZ_ModifyFlags),&Parms);
        return Parms.ReturnValue;
    }
    DECLARE_CLASS(ABotz_NavigBase,ANavigationPoint,0,FerBotz)
    NO_DEFAULT_CONSTRUCTOR(ABotz_NavigBase)
};


class FERBOTZ_API ABotz_PathLoader : public AActor
{
public:
#include "UnPathLoader.h"
};

#endif

AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execClearPrunes);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execIsPruned);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execAddPrune);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execInitPruned);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execReadArray);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execSaveArray);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execArrayToCur);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execAddCurToArray);
AUTOGENERATE_FUNCTION(ABotz_PathLoader,-1,execClearArray);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execFreeUpstreamSlot);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execFreePathSlot);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execClearAllPaths);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execIsConnectedTo);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execConnectedDests);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execUnusedReachSpec);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execEditReachSpec);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execExistingPath);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execPathCandidates);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execCreateReachSpec);
AUTOGENERATE_FUNCTION(ABotz_NavigBase,-1,execLockActor);
AUTOGENERATE_FUNCTION(ABotz,-1,execNavigationActors);
AUTOGENERATE_FUNCTION(ABotz,-1,execPawnActors);
AUTOGENERATE_FUNCTION(ABotz,-1,execFindBasedInv);
AUTOGENERATE_FUNCTION(ABotz,-1,execOr_ActorActor);
AUTOGENERATE_FUNCTION(ABotz,-1,execPopRouteCache);
AUTOGENERATE_FUNCTION(ABotz,-1,execCollideTrace);


#ifndef NAMES_ONLY
#undef AUTOGENERATE_NAME
#undef AUTOGENERATE_FUNCTION
#endif NAMES_ONLY

#if _MSC_VER
#pragma pack (pop)
#endif
